#ifndef __HEADER_TS_INFO
#define __HEADER_TS_INFO

#include "mpsys.h"
#include "mpsys_parser.h"
#include "dvbsi_parser.h"

enum info_state_status { TS_INFO_NIT, TS_INFO_PAT, TS_INFO_SDT, TS_INFO_MAP, TS_INFO_FINISHED };

#define TS_INFO_MAX_PROGRAMS 500

struct info_state_st {
	enum info_state_status status;
	
	/* in-table state */
	int version;
	int section;
	
	/* PAT */
	int transport_stream_id;
	
	int programs_count;
	struct ts_program_association_programs_st programs[TS_INFO_MAX_PROGRAMS];
		
	/* SDT */
	service_description service;
	unsigned char service_buffer [DVB_MAX_SECTION_LENGTH]; /* memory for descriptors in 'service' */
	int services_next; /* index of current service in current section of SDT */
	
	/* MAP */
	int service_info_id;
	
	/* config */
	int do_nit;
	int verbose;
	
	/* print routines */
	void (*print_network_satellite) (satellite_delivery *del);
	void (*print_network_terrestrial) (terrestrial_delivery *del);
	void (*print_network_cable) (cable_delivery *del);
	void (*print_network_end) (void);
	void (*print_service) (struct service_description_services_st *);
	void (*print_service_end) (void);
	void (*print_map) (ts_program_map *);
};

void reset_info (struct info_state_st *);
void set_info_short_text (struct info_state_st *state);
void set_info_xml (struct info_state_st *state);
void process_info (struct info_state_st *info_state, int pid, buffer *payload);
int info_pid (struct info_state_st *info);

#endif
